#include "stdafx.h"

//=========================================================================
// File: main.cpp
//		AvP[V̎vłB
//=========================================================================

#include "wininet++.h"
#include "parser.h"
#include "judge.h"
using namespace wipp;
using namespace parser;
using namespace judge;
using namespace boost::filesystem;



//--------------------------------------------------------------
// w肳ꂽ^Oƈv鍀ڂXgƂďo
//--------------------------------------------------------------

void output(
	ofstream& fout, const string& tag_rexp, const vector<PageInfo>& infolist )
{
	fout << "<dl class='athena_output'>" << endl;

	RegEx r(tag_rexp);
	for(unsigned i=0; i!=infolist.size(); ++i)
		if( r.Search(infolist[i].tag) )
		{
			fout << "<dt><a href='" << infolist[i].genLinkString() << "'>"
				<< infolist[i].name << "</a> ("
				<< infolist[i].genStateString()
				<< ")</dt>" << endl;
			fout << "<dd>" << infolist[i].comment << "</dd>" << endl;
		}

	fout << "</dl>" << endl;
}

//--------------------------------------------------------------
// template_* t@C̖ߕathenȁo͂ɒu
//--------------------------------------------------------------

void update(
	const string& infile, const string& outfile, const vector<PageInfo>& infolist )
{
	ifstream fin (  infile.c_str() );
	ofstream fout( outfile.c_str() );
	if( fin && fout )
	{
		RegEx r( "\\s*<!--\\s*INSERT-ATHENA:\\s*([^\\s].*[^\\s])\\s*-->\\s*" );

		string line;
		while( getline(fin, line) )
			if( r.Match(line) )
				output( fout, r.What(1), infolist );
			else
				fout << line << endl;
	}
}

//--------------------------------------------------------------
// Ȍ񌋉ʃf[^ēǂݍ
//--------------------------------------------------------------

void load_prev_result( const char* filename, vector<PageInfo>& infolist )
{
	map< string, tuple<string,string> > prev_results;

	// t@Cǂ
	{
		ifstream fin(filename);
		if( fin )
		{
			string line;
			char_separator<char> sep(",");
			while( getline(fin, line) )
			{
				string a,b,c;
				tokenizer< char_separator<char> > tok( line, sep );
				tokenizer< char_separator<char> >::iterator it = tok.begin();
				if( it != tok.end() ) a = *it++;
				if( it != tok.end() ) b = *it++;
				if( it != tok.end() ) c = *it++;

				prev_results[a] = make_tuple(b,c);
			}
		}
	}

	// f[^\֔f
	for(unsigned i=0; i!=infolist.size(); ++i)
	{
		if( infolist[i].check.empty() )
			infolist[i].check = infolist[i].url;
		infolist[i].status_code = -1;

		try {
			infolist[i].last_update = optional<Time>(
				lexical_cast<Time>( prev_results[infolist[i].check].get<0>() )
			);
		} catch( bad_lexical_cast ) {}
		infolist[i].digest = prev_results[infolist[i].check].get<1>();
	}
}

//--------------------------------------------------------------
// ̏񌋉ʃf[^ۑ
//--------------------------------------------------------------

void save_result( const char* filename, const vector<PageInfo>& infolist )
{
	ofstream fout(filename);
	if( fout )
		for(unsigned i=0; i!=infolist.size(); ++i)
		{
			fout << infolist[i].check << ",";
			if( infolist[i].last_update )
				fout << *infolist[i].last_update;
			else
				fout << "_____________________";
			fout << "," << infolist[i].digest << endl;
		}
}

//--------------------------------------------------------------
// ԏɃ\[g邽߂̕⏕֐
//--------------------------------------------------------------

bool compare_by_time( const PageInfo& lhs, const PageInfo& rhs )
{
	if( lhs.last_update )
		if( rhs.last_update )
			return *lhs.last_update > *rhs.last_update;
		else
			return true;
	else
		return false;
}

//--------------------------------------------------------------
// ߂
//--------------------------------------------------------------

void app_main(int argc, const char* argv[])
{
	if( argc!=2 && argc!=3 )
	{
		cerr << "usage: athena inputdir [outputdir]" << endl;
		return;
	}

	// `t@CpX...
	path idir( argv[1], native );
	path odir( argc==2 ? argv[1] : argv[2], native );
	path pagelistfile = idir/"Athenafile";
	path resultfile   = odir/"Athena.result";

	// y[WXgJ
	vector<PageInfo> pis = parse(pagelistfile.native_file_string().c_str());

	// Ǒʂ[h
	load_prev_result( resultfile.native_file_string().c_str(), pis );

	// XV`FbN
	Detector().judgement( pis );

	// ʂZ[u
	save_result( resultfile.native_file_string().c_str(), pis );

	// Vɕёւ
	stable_sort( pis.begin(), pis.end(), compare_by_time );

	// etemplateXV
	for( directory_iterator it(idir), end; it!=end; ++it )
		if( it->leaf().find("template_")==0 )
		{
			string infile  = it->native_file_string();
			string outfile = (odir / it->leaf().substr(9)).native_file_string();
			update( infile, outfile, pis );
		}
}

//--------------------------------------------------------------

int main(int argc, const char* argv[])
{
	// unittests
	#ifdef _DEBUG
	{
		extern int test_main();
		test_main();
	}
	#endif

	// Av{̎s
	try
	{
		app_main(argc, argv);
	}
	catch( exception& e )
	{
		cerr << e.what() << endl;
	}
	return 0;
}
